# The Maze

Simulation of travelers in a maze searching the single exit point using the GLUT library for an OpenGL GUI.   
Developed by Austin Agronick & Daniel Aleksa.  

## Runtime Screenshot
![runtime screenshot: screenshot.png](screenshot.png)  

## Usage
./main {grid width} {grid height} {number of travelers} {moves to grow segment}  

## Architecture
Each traveler thread in our program is given a ThreadInfo struct that stores the threadID, thread index, a Boolean that is true if the traveler gets temporarily stuck on the grid, a string that store the threads running state, and a mutex lock for access to the traveler’s data.   
Each traveler thread will run in a while loop until it reaches the exit. The escape key will cause threads to return on their next iteration, however this functionality is broken in v4 due to mutex locks blocking. The traveler considers four potential moves on each loop, storing moves occupied by another traveler in a separate vector. Moves to a partition location are only stored if that partition can be moved out of the way for the traveler to pass through. If a partition is moving and becomes blocked by a traveler, it will wait for that traveler to move until the next partition location becomes free and then continue to move. If all potential move locations are occupied by other travelers, the traveler will wait for them to leave and move to the first free location. Locations occupied by travelers with a status of stuck will not be considered, as this will cause a cycle of travelers to be waiting for other travelers to move. If a traveler is surround by barriers and/or stuck travelers it will be considered trapped and then terminated to prevent a blockage of travelers on the grid. Otherwise, the traveler will move to the closest location to the exit that is the least previously visited. Going to the least previously visited location provides a very inefficient traversal but prevents travelers from becoming stuck on the grid as they will continuously try new routes getting closer and closer to the exit. Since the mutex locks’ critical sections are designed to be as short as possible, if a lock is acquired and the desired next move location is no longer viable, the thread loop will restart to reconsider the available moves. 
A major difficulty in programming v4 was the complications of mutex locks. Since there is no inherent way to determine what thread has a mutex lock, printing out a status of locked and unlocked after every mutex operation allowed us to simply track the status of the threads, and discover where they were blocking. Another difficulty was with moving partitions, as they must be moved while interacting with other travelers. Also, if one traveler moved a partition, then another traveler reacquires a mutex lock to move the partition, their previously gathered move information was now incorrect. A very difficult issue to debug as we thought the issue was with the way a partition was being moved, while the bug was actually rooted in mutex lock logic.  
Identified limitations of the program include that it will sometimes crash if moves to grow segment is 1. Joining threads after escape key press doesn’t work in v4 due to mutex locks blocking. The partitions are limited in movement by walls and other partitions. The method by which trapped travelers terminate is not precise as sometimes they could become unstuck if the stuck traveler they encounter is waiting on an unstuck traveler that will eventually free its occupying location. The deadlocking issue is present in v4 as a traveler thread locks the grid and another traveler locks a traveler. Then if the first traveler tries to lock the already locked traveler, it will wait while the second traveler waits for the grid to become unlocked. In v1, v2, and v3, travelers will often become trapped as they cannot move the partitions. We resolve this issue by simply terminating permanently stuck travelers.   
A potential solution to the deadlocking problem would require a struct to keep record of the status of each resource and what is requesting it. The status would consist of if the resource is locked or if it is released. Threads which desire a mutex lock will be placed into that mutex’s queue of requests and be served in first come first serve order. While a thread is waiting for a resource to be free, it will free the resource that it has acquired, to ensure that threads can take turns processing the thread and grid data. Once a thread releases a lock on the grid and then acquires a lock on a thread, it can wait until it reacquires the grid lock, perform its operation and then free the thread and the grid lock until the grid lock can be reacquired, then move on to the next desired thread lock. This exchange of resources allows threads to release their locks and wait until they can acquire both necessary locks and then release to provide the locks to another thread.
